/* loadlib.c
* a simple dlfcn interface for Lua
*/

#include <dlfcn.h>

#include "lua.h"
#include "lauxlib.h"

static int loadlib(lua_State *L)		/* loadlib(path,init) */
{
 const char *path=luaL_check_string(L,1);
 const char *init=luaL_check_string(L,2);
 void *lib=dlopen(path,RTLD_NOW);
 if (lib!=NULL)
 {
  lua_CFunction f=(lua_CFunction) dlsym(lib,init);
  if (f!=NULL)
  {
   int n=f(L);
   lua_pushnumber(L,1);
   return n+1;
  }
 }
 lua_pushnil(L);
 lua_pushstring(L,(lib!=NULL) ? "init" : "open");
 lua_pushstring(L,dlerror());
 if (lib!=NULL) dlclose(lib);
 return 3;
}

int lua_loadlibopen(lua_State *L)
{
 lua_register(L,"loadlib",loadlib);
 return 0;
}
